.\" $NetBSD: kttcp.4,v 1.4 2006/12/28 11:44:19 wiz Exp $
.\"
.\" Copyright (c) 2003 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd December 2, 2006
.Dt KTTCP 4
.Os
.Sh NAME
.Nm kttcp
.Nd kernel support for testing network throughput
.Sh SYNOPSIS
.Cd "pseudo-device kttcp"
.Sh DESCRIPTION
This driver provides kernel support for testing network
throughput from the perspective of the kernel.
It is similar in spirit to the classic ttcp network benchmark
program, the main difference being that with kttcp, the kernel is
the source and sink of the data.
.Pp
Testing like this is useful for a few reasons:
.Bl -enum
.It
This allows us to know what kind of performance we can
expect from network applications that run in the kernel
space, such as the NFS server or the NFS client.
These applications don't have to move the data to/from userspace,
and so benchmark programs which run in userspace don't give us an
accurate model.
.It
Since data received is just thrown away, the receiver is very fast.
This can provide better exercise for the sender at the other end.
.It
Since the
.Nx
kernel currently uses a run-to-completion
scheduling model, kttcp provides a benchmark model where
preemption of the benchmark program is not an issue.
.El
.Sh SEE ALSO
.Pa pkgsrc/benchmarks/kttcp ,
.Pa pkgsrc/benchmarks/ttcp
